B = [0 0.1813 0.2122];
A = [1 -0.6065];
Ts= 5;

plant = filt(B,A,Ts);

wn = 0.25;
damp = 0.8;

Sys_des=c2d(tf(wn^2,[1 2*damp*wn wn^2]),Ts);
P=Sys_des.den{1};

[Rp,Sp,nrp,nsp]=bezoutd(A,B,[1 -1],1,P);


R = Rp;
S = conv(Sp,[1 -1]);
T = R;

 
AR=conv(A,R);
AS=conv(A,S);
BR=conv(B,R);
P=AS+BR;
Sup=filt(AR,P,5);
[mag,phase]=bode(Sup,[0.01:0.001:pi/5]);
mag=mag(:);

puls=[0.01:0.001:pi/5];
z=exp(i*2*[0.01:0.001:pi/5]);
puls_norm=puls*2.5/pi;
plot(puls_norm,20*log10(mag),'k-','linewidth',2);
hold on
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Paux = conv([1 -0.15],[1 -0.15]);
% P = conv(P(1:end-1),Paux);
% [Rp,Sp,nrp,nsp]=bezoutd(A,B,[1 -1],1,P);
% R = Rp;
% S = conv(Sp,[1 -1]);
% T = R;

R = [2.330380  -1.248607   0.014350];
S = [1.000000  -0.654345  -0.345655];

AR=conv(A,R);
AS=conv(A,S);
BR=conv(B,R);
P=[AS 0]+BR;
Sup=filt(AR,P,5);
[mag,phase]=bode(Sup,[0.01:0.001:pi/5]);
mag=mag(:);
plot(puls_norm,20*log10(mag),'k-.','linewidth',2)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

wn = 0.20;
damp = 0.8;

Sys_des=c2d(tf(wn^2,[1 2*damp*wn wn^2]),Ts);
P=Sys_des.den{1};

[Rp,Sp,nrp,nsp]=bezoutd(A,B,[1 -1],1,P);


R = Rp;
S = conv(Sp,[1 -1]);
T = R;

 
AR=conv(A,R);
AS=conv(A,S);
BR=conv(B,R);
P=AS+BR;
Sup=filt(AR,P,5);
[mag,phase]=bode(Sup,[0.01:0.001:pi/5]);
mag=mag(:);
plot(puls_norm,20*log10(mag),'k:','linewidth',2)

title('Sup Magnitude Frequency Responses','FontSize',12,'FontWeight','Bold');
xlabel('Frequency (f/f_{s})','FontSize',12,'FontWeight','Bold');
ylabel('Magnitude (dB)','FontSize',12,'FontWeight','Bold');
%set(gca,'FontSize',14,'FontWeight','Bold');
% text(0.35,12,'omega = 0.25 rad/sec','FontSize',14,'FontWeight','Bold');
% text(0.35,10,'omega = 0.20 rad/sec','FontSize',14,'FontWeight','Bold');
% text(0.3,8,'omega = 0.25 rad/sec and aux. poles in 0.15','FontSize',14,'FontWeight','Bold');
legend(['{\omega}' ' = 0.25 rad/sec'],['{\omega}' ' = 0.25 rad/sec, aux. poles in 0.15'],['{\omega}' ' = 0.20 rad/sec'],4);
axis([0 0.5 0 14]);
grid on
