B = [0 0.1 0.2];
A = [1 -1.3 0.42];
Ts= 1;

plant = filt(B,A,Ts);

wn = 0.5;
damp = 0.9;

Sys_des=c2d(tf(wn^2,[1 2*damp*wn wn^2]),Ts);
Am=Sys_des.den{1};
Bm=Sys_des.num{1}(2:end);

wn = 0.4;
damp = 0.9;

Sys_des=c2d(tf(wn^2,[1 2*damp*wn wn^2]),Ts);
P=Sys_des.den{1};

[Rp,Sp,nrp,nsp]=bezoutd(A,B,[1 -1],1,P);


R = Rp;
S = conv(Sp,[1 -1]);
T = P/sum(B);

sys_OL = series(filt(1,S,Ts),plant);
sys_CL = feedback(sys_OL,filt(R,1,Ts));

sys_full = series(filt(T,1,Ts),sys_CL);

[tt,xx,yy]=sim('table_3_3_2');
time=y.time;yout=y.signals.values;uout=u.signals.values;
subplot(2,1,1)
plot(time,yout,'k','linewidth',2);
title('Plant Output','FontSize',12,'FontWeight','Bold');
xlabel('Time (t/T_{s})','FontSize',12,'FontWeight','Bold');
%ylabel('amplitude (%)','FontSize',14,'FontWeight','Bold');
%set(gca,'FontSize',14,'FontWeight','Bold');
axis([0 100 0 1.1])
grid on
subplot(2,1,2)
plot(time,uout,'k','linewidth',2);
title('Control Signal','FontSize',12,'FontWeight','Bold');
xlabel('Time (t/T_{s})','FontSize',12,'FontWeight','Bold');
%ylabel('amplitude (%)','FontSize',14,'FontWeight','Bold');
%set(gca,'FontSize',14,'FontWeight','Bold');
axis([0 100 0 1.4])
grid on