B = [0 0 0 0.3];
A = [1 -0.7];
Ts= 1;

plant = filt(B,A,Ts);

wn = 1;
damp = 0.9;

Sys_des=c2d(tf(wn^2,[1 2*damp*wn wn^2]),Ts);
P=Sys_des.den{1};

[Rp,Sp,nrp,nsp]=bezoutd(A,B,[1 -1],1,P);


R = Rp;
S = conv(Sp,[1 -1]);
%T = R;

puls=[0.01:0.001:pi/Ts];
AS=conv(A,S);
BR=conv(B,R);
AR=conv(A,R);
P=AS+BR;
Syp=filt(AS,P,Ts);
[mag,phase]=bode(Syp,puls);
mag=mag(:);



z=exp(i*2*puls);
sys=filt(1,[1 -1],Ts);
[mag1,phase]=bode(sys,puls);
[mag1,phase]=bode(sys,puls);
mag1a=1-mag1;
mag1b=1+mag1;
puls_norm=puls*Ts/(2*pi);
index=find(mag1a>0);
mag1a=mag1a(:);
mag1b=mag1b(:);
plot(puls_norm,20*log10(mag),'k:','linewidth',2);
hold on
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

wn = 0.16*2*pi;
damp = 0.21;

Sys_des=c2d(tf(wn^2,[1 2*damp*wn wn^2]),Ts);
Hs=Sys_des.den{1};

wn = 0.16*1.02*2*pi;
damp = 0.34;

Sys_des=c2d(tf(wn^2,[1 2*damp*wn wn^2]),Ts);
Paux=Sys_des.den{1};

wn = 1;
damp = 0.9;

Sys_des=c2d(tf(wn^2,[1 2*damp*wn wn^2]),Ts);
P=Sys_des.den{1};

P = conv(P,Paux);

[Rp,Sp,nrp,nsp]=bezoutd(A,B,conv(Hs,[1 -1]),1,P);


R = conv(Rp,1);
S = conv(Sp,conv(Hs,[1 -1]));
%T = R;

 
AS=conv(A,S);
BR=conv(B,R);
AR=conv(A,R);
P=AS+BR;
Syp=filt(AS,P,Ts);
[mag,phase]=bode(Syp,puls);
mag=mag(:);
plot(puls_norm,20*log10(mag),'k','linewidth',2);
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

maximum=6*ones(length(puls),1);

delmarg_idx=find(maximum>=20*log10(mag1b));
modmarg_idx=find(maximum<=20*log10(mag1b));
% plot(puls_norm(modmarg_idx),maximum(modmarg_idx),'k-.','linewidth',2)
% plot(puls_norm(delmarg_idx),20*log10(mag1b(delmarg_idx)),'k--','linewidth',2)
% plot(puls_norm(index),20*log10(mag1a(index)),'k--','linewidth',2)

title('Syp Magnitude Frequency Responses','FontSize',12,'FontWeight','Bold');
xlabel('Frequency (f/f_{s})','FontSize',12,'FontWeight','Bold');
ylabel('Magnitude (dB)','FontSize',12,'FontWeight','Bold');
%set(gca,'FontSize',14,'FontWeight','Bold');
% legend('H_{S} = 1, P_{F} = 1',['H_{S} = ( ' '{\omega}' ' = 1.005, ' '{\zeta}' ' = 0.21), ','P_{F} = ( ' '{\omega}' ' = 1.025, ' '{\zeta}' ' = 0.34)'],...
%                                     'Template for Modulus margin','Template for Delay margin = T_{s}',4)
legend('H_{S} = 1, P_{F} = 1',['H_{S} = ( ' '{\omega}' ' = 1.005, ' '{\zeta}' ' = 0.21), ','P_{F} = ( ' '{\omega}' ' = 1.025, ' '{\zeta}' ' = 0.34)'],4)
axis([0 0.5 -25 8])
grid on






