Ts = 1;
Mt = -4;
ft = 0.16;
xid = 0.4;

[num,den,om_n,xi_n,om_d,xi_d]=filter22(Mt,ft,xid,Ts);

bode(filt(num,den,Ts));

sys_cont_disc = filt(num,den,Ts);

[mag,phase]=bode(sys_cont_disc,puls);
mag=mag(:);
phase=phase(:);


puls=puls;
puls_norm=puls*Ts/(2*pi);

subplot(2,1,1)

plot(puls_norm,20*log10(mag),'k','linewidth',2);

hold on

subplot(2,1,2)

plot(puls_norm,phase,'k','linewidth',2);

hold on
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

wn = 0.16*2*pi;
damp_num = 0.25;
damp_den = 0.4;

Sys_num=c2d(tf(wn^2,[1 2*damp_num*wn wn^2]),Ts);
num_disc=Sys_num.den{1};

Sys_den=c2d(tf(wn^2,[1 2*damp_den*wn wn^2]),Ts);
den_disc=Sys_den.den{1};

filt_correct=sum(den_disc)/sum(num_disc);

sys_disc=filt_correct*filt(num_disc,den_disc,Ts);
[mag,phase]=bode(sys_disc,puls);
mag=mag(:);
phase=phase(:);

subplot(2,1,1)

plot(puls_norm,20*log10(mag),'k:','linewidth',2);

title('Bandstop Filters Magnitude Frequency Responses','FontSize',12,'FontWeight','Bold');
xlabel('Frequency (f/f_{s})','FontSize',12,'FontWeight','Bold');
ylabel('Magnitude (dB)','FontSize',12,'FontWeight','Bold');
%legend(['From continuous-time filter ' '{\rightarrow} ' 'discrete-time filter'],'Direct digital design',4)
legend('Discretization of a continuous-time filter','Direct digital filter design',4)
axis([0 0.5 -4.5 0])
grid on


subplot(2,1,2)

plot(puls_norm,phase,'k:','linewidth',2);

title('Bandstop Filters Phase Frequency Responses','FontSize',12,'FontWeight','Bold');
xlabel('Frequency (f/f_{s})','FontSize',12,'FontWeight','Bold');
ylabel('Phase (deg)','FontSize',12,'FontWeight','Bold');
%legend(['From continuous-time filter ' '{\rightarrow} ' 'discrete-time filter'],'Direct digital design',4)
legend('Discretization of a continuous-time filter','Direct digital filter design',4)
axis([0 0.5 -15 15])
grid on

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%








