B = [0 0 0 0.3];
A = [1 -0.7];
Ts= 1;

plant = filt(B,A,Ts);

wn = 1;
damp = 0.9;

Sys_des=c2d(tf(wn^2,[1 2*damp*wn wn^2]),Ts);
P=Sys_des.den{1};

[Rp,Sp,nrp,nsp]=bezoutd(A,B,[1 -1],1,P);


R = Rp;
S = conv(Sp,[1 -1]);
%T = R;

puls=[0.01:0.001:pi/Ts]; 
AS=conv(A,S);
BR=conv(B,R);
AR=conv(A,R);
P=AS+BR;
Sup=filt(AR,P,Ts);
[mag,phase]=bode(Sup,puls);
mag=mag(:);



puls_norm=puls*Ts/(2*pi);
plot(puls_norm,20*log10(mag),'k:','linewidth',2);
hold on

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


[Rp,Sp,nrp,nsp]=bezoutd(A,B,[1 -1],[1 0.5],P);


R = conv(Rp,[1 0.5]);
S = conv(Sp,[1 -1]);
%T = R;

 
AS=conv(A,S);
BR=conv(B,R);
AR=conv(A,R);
P=AS+BR;
Sup=filt(AR,P,Ts);
[mag,phase]=bode(Sup,puls);
mag=mag(:);
plot(puls_norm,20*log10(mag),'k--','linewidth',2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[Rp,Sp,nrp,nsp]=bezoutd(A,B,[1 -1],[1 1],P);


R = conv(Rp,[1 1]);
S = conv(Sp,[1 -1]);
%T = R;

 
AS=conv(A,S);
BR=conv(B,R);
AR=conv(A,R);
P=AS+BR;
Sup=filt(AR,P,Ts);
[mag,phase]=bode(Sup,puls);
mag=mag(:);
plot(puls_norm,20*log10(mag),'k','linewidth',2);


title('Sup Magnitude Frequency Responses','FontSize',12,'FontWeight','Bold');
xlabel('Frequency (f/f_{s})','FontSize',12,'FontWeight','Bold');
ylabel('Magnitude (dB)','FontSize',12,'FontWeight','Bold');
axis([0 0.5 -40 20])
legend('H_{R} = 1','H_{R} = 1 + 0.5q^{-1}','H_{R} = 1 + q^{-1}',4)
grid on






