B = [0 0 0 0.5];
A = [1 -1];
Ts= 1;

plant = filt(B,A,Ts);

wn = 0.628;
damp = 0.9;

Sys_des=c2d(tf(wn^2,[1 2*damp*wn wn^2]),Ts);
P=Sys_des.den{1};

[Rp,Sp,nrp,nsp]=bezoutd(A,B,1,[1 0 1],P);


R = conv(Rp,[1 0 1]);
S = conv(Sp,1);
%T = R;

puls=[0.01:0.001:pi/Ts]; 
AS=conv(A,S);
BR=conv(B,R);
AR=conv(A,R);
P=AS+BR;
Syp=filt(AS,P,Ts);
[mag,phase]=bode(Syp,puls);
mag=mag(:);



puls_norm=puls*Ts/(2*pi);
puls=[0.01:0.001:pi/1];
z=exp(i*2*[0.01:0.001:pi/1]);
sys=filt(1,[1 -1],1);
[mag1,phase]=bode(sys,[0.01:0.001:pi/1]);
[mag1,phase]=bode(sys,puls);
mag1a=1-mag1;
mag1b=1+mag1;
puls_norm=puls*0.5/pi;
index=find(mag1a>0);
mag1a=mag1a(:);
mag1b=mag1b(:);
plot(puls_norm,20*log10(mag),'k:','linewidth',2);
hold on

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

wn = 0.628;
damp = 0.9;

Sys_des=c2d(tf(wn^2,[1 2*damp*wn wn^2]),Ts);
P=Sys_des.den{1};
Paux = [1   -1.542695     0.703280];
P = conv(P,Paux);
Hs = [1    -1.600545       0.767974];
Hr = [1 0 1];

[Rp,Sp,nrp,nsp]=bezoutd(A,B,Hs,Hr,P);


R = conv(Rp,Hr);
S = conv(Sp,Hs);
%T = R;

 
AS=conv(A,S);
BR=conv(B,R);
AR=conv(A,R);
P=AS+BR;
Syp=filt(AS,P,Ts);
[mag,phase]=bode(Syp,puls);
mag=mag(:);
plot(puls_norm,20*log10(mag),'k--','linewidth',1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


wn = 0.9;
damp = 0.9;

Sys_des=c2d(tf(wn^2,[1 2*damp*wn wn^2]),Ts);
P=Sys_des.den{1};
Paux = [1   -1.542695     0.703280];
P = conv(P,Paux);
Hs = [1    -1.600545       0.767974];
Hr = [1 0 1];

[Rp,Sp,nrp,nsp]=bezoutd(A,B,Hs,Hr,P);


R = conv(Rp,Hr);
S = conv(Sp,Hs);
%T = R;

 
AS=conv(A,S);
BR=conv(B,R);
AR=conv(A,R);
P=AS+BR;
Syp=filt(AS,P,Ts);
[mag,phase]=bode(Syp,puls);
mag=mag(:);
plot(puls_norm,20*log10(mag),'k','linewidth',2);

maximum=6*ones(length(puls),1);

delmarg_idx=find(maximum>=20*log10(mag1b));
modmarg_idx=find(maximum<=20*log10(mag1b));
plot(puls_norm(modmarg_idx),maximum(modmarg_idx),'k-.','linewidth',2)
plot(puls_norm(delmarg_idx),20*log10(mag1b(delmarg_idx)),'k--','linewidth',2)
plot(puls_norm(index),20*log10(mag1a(index)),'k--','linewidth',2)
title('Syp Magnitude Frequency Responses','FontSize',12,'FontWeight','Bold');
xlabel('Frequency (f/f_{s})','FontSize',12,'FontWeight','Bold');
ylabel('Magnitude (dB)','FontSize',12,'FontWeight','Bold');
axis([0 0.5 -15 10])
legend('A','B','C','Template for Modulus margin','Template for Delay margin = T_{s}',4)
grid on






