B = [0 0.1813 0.2122];
A = [1 -0.6065];
Ts= 5;

plant = filt(B,A,Ts);

wn = 0.15;
damp = 0.8;

Sys_des=c2d(tf(wn^2,[1 2*damp*wn wn^2]),Ts);
P=Sys_des.den{1};

[Rp,Sp,nrp,nsp]=bezoutd(A,B,[1 -1],1,P);


R = Rp;
S = conv(Sp,[1 -1]);
T = sum(R);

sys_OL = series(filt(1,S,Ts),plant);
sys_CL = feedback(sys_OL,filt(R,1,Ts));

sys_full = series(filt(T,1,Ts),sys_CL);

[tt,xx,yy]=sim('table_3_2_1');
time=y.time;yout=y.signals.values;uout=u.signals.values;
subplot(2,1,1)
plot(time/5,yout,'k','linewidth',2);
title('Plant Output','FontSize',12,'FontWeight','Bold');
xlabel('Time (t/T_{s})','FontSize',12,'FontWeight','Bold');
%ylabel('amplitude (%)','FontSize',14,'FontWeight','Bold');
%set(gca,'FontSize',14,'FontWeight','Bold');
axis([0 100 0 1.1])
grid on
subplot(2,1,2)
plot(time/5,uout,'k','linewidth',2);
title('Control Signal','FontSize',12,'FontWeight','Bold');
xlabel('Time (t/T_{s})','FontSize',12,'FontWeight','Bold');
%ylabel('amplitude (%)','FontSize',14,'FontWeight','Bold');
%set(gca,'FontSize',14,'FontWeight','Bold');
axis([0 100 0 1.6])
grid on